
;*******************************************************************************
;				RDA5807M_&_Nokia5110.asm
;	 FM-   RDA5807M  LCD- Nokia5110
;  ATMEGA8    .  8 .
; 		  :
;-*-          .
;-*-         
;        .
;-*-      .
;-*-       .
;-*-  "-"   ,   .
;-*-        .
;-*-      .
;-*-      EEPROM.
;-*-       
;-*-    I2C.
;
;  :
; PB0 - .   -
; PB1 - D/C     (1)   (0) LCD
; PB2 -     (0) LCD
; PB3 - DIN   LCD
; PB4 - RES   LCD (0)
; PB5 - CLK   LCD
; PB7 - .   -
;
; PC0 -   
; PC1 -   
; PC2 -  
; PC3 
; PC4 -   
; PC5 -   
;
;*******************************************************************************
	;     /
    .NOLIST                 ; 
	.include "m8def.inc"	;   - ATMega8
    .LIST                   ; 
    .device ATmega8         ; 
	
  	;   
	.def temp  = r16 		;
	.def temp1 = r17 		; 
	.def temp2 = r18 		; 
	.def temp3 = r19 		;  
	.def flags = r20 		; 
	.def time  = r21		;  
	.def F_3H  = r22		;.   
	.def F_3L  = r23		;.   
	.def freq  = r24		;   ( )
;-----------------------------------------------------------------------------
	;  LCD  
	.equ LCD_DC_port  = PORTB
	.equ LCD_DC   = 1			;  - /  PORTB.1
	.equ LCD_SCE_port = PORTB
	.equ LCD_SCE  = 2			; .    PORTB.2
	.equ LCD_SDIN_port = PORTB
	.equ LCD_SDIN = 3			;   PORTB.3
	.equ RES_port = PORTB
	.equ RES 	  = 4			;    PORTB.4
	.equ LCD_SCLK_port = PORTB
	.equ LCD_SCLK = 5			;   PORTB.5
;-----------------------------------------------------------------------------
;	!        
	.equ Nst   = 14			;  
;	.equ Tm_l  = 255		;  
;===============================================================================
	.DSEG					;    SRAM ()
	.ORG 0x060				;   
	decnum: 	.BYTE 5		;A    
	seek_fm:	.byte 1		;  
	read_fm:	.byte 1 	; ()  
	level:		.byte 1		; 
	volume:		.byte 1		;
	
;=============================================================================
	.ESEG					;    EEPROM
	 Fst_EE:	.BYTE 1 	;   ( )
;	 Vol_EE:	.BYTE 1 	; 
;=============================================================================
.CSEG		;  
.ORG 0 		; 
	rjmp RESET			;Reset
	reti			;  INT 0
	reti				;  INT 1
	reti				; / 2  
	reti				; / 2  
	reti  				; / 1   
	reti				; / 1     
	reti				; / 1     
	reti				; / 1  
	rjmp OVF_T0			; / 0  
	reti				;  SPI 
	reti				; UART   
	reti				; UART   
	reti				; UART  
	reti 				;   
	reti				; EEPROM 
	reti				;   
	reti    			;  - 2- 
	reti				; SPM
	
;============================================================================
RESET:	;   ,  
		;  
		LDI 	Temp, LOW(RAMEND)
		OUT 	SPL, Temp
		LDI 	Temp, HIGH(RAMEND)
		OUT 	SPH, Temp
		CLI							;   
;-----------------------------------------------------------------------------
		;  B,  .  LCD-
	 	ldi temp,0b11111111			;
		out DDRB,temp   			;      
		ldi temp,0b00000110			;   RES  SE 
		out PORTB,temp   			;
			;  ,  .    
	 	ldi temp,0b00000000			;      
		out DDRC,temp   			;
		ldi temp,0b11111111			;
		out PORTC,temp   			;  
		
			;  D
	 	ldi temp,0b00000000			;   D  
		out DDRD,temp				;
		ldi temp,0b11111111			;
		out PORTD,temp				;  
		
			;  0   2
		;  :
		; (1/8000000)*1024)*256=0,032768  = 32,768   . 1/1024
		clr temp					;   
		out TCNT0,temp				;
		ldi temp,0b00000101			;  0   1/1024
		out TCCR0,temp				;
		ldi temp,0b00000001			; .   
		out TIMSK,temp				;
		
		sei                         ;  
		
;----------------------------------------------------------------------
	.MACRO DELAY					; 1   32 
		ldi time,@0					;    0
 		tst time					;,  0  R21  0
		brne PC-1					;
	.ENDMACRO
	
	.MACRO LOAD_ADDR 		 		;  16  
		ldi @0l,low(@1)   			;: LOAD_ADDR Z,12365
		ldi @0h,high(@1)  			;
	.ENDMACRO
		
	.MACRO 	POZ_LCD					;    LCD:
		ldi temp,@0					;    ,
		rcall lcd_X					;
		ldi temp,@1					;   
		rcall lcd_Y					;
	.ENDMACRO						;: POZ_LCD 12,5
	
;===================   ==================================
		; 
		rcall lcd_init				; LCD 
		rcall lcd_clr				; LCD
		;    
		POZ_LCD 0,0					;0- , 0- 
		LOAD_ADDR Z,Messg1*2		;.  Z  
		rcall Str_LCD				; .  LCD
		
;------------------------------------------------------------------------------
		;  RDA5807
		rcall speed_clk				;    I2C
		ldi YL,LOW(Fst_EE)			;.  Y ..  
		clr YH						;
		ldi temp,15					; 
		sts volume,temp				;   = 15
		rcall Rd_St					;     EEPROM
		cpi freq,210				;    >210
		brlo PC+2					; 210+870=1080
		clr freq					;  freq =0
		;
		DELAY 20					; 656 
		rcall Prnt_F				;   
			; 
		ldi temp,0b11010010			;(02H) ., DMUTE=1,,,
									; SEEKUP=1, SEEK=0 ( )
		mov r5,temp					; - 
		rcall Config_RDA5807		; RDA5807
		DELAY 20					; 656 
			;     
		rcall rekog					;/  
		; 
		clr r2						;  
		clr r8						;
		clr r10						;
		clr freq					;  
		clr temp3					;  R19
		
;------------------------------------------------------------------
main: 			; 
		in temp,PINC				;  
		andi temp,0b00000111		; 
		cpi temp,7					;   , -
		breq main					;   
		;
		sbrs temp,2					;   , -
		rjmp mn_au					;   
		;   
		mov  temp1,temp				;
		andi temp1,0b00000011		;  
		cpi temp1, 1				;   1, 
		breq mn_1					;   R10=1
		cpi temp1, 2				;   2, 
		breq mn_2					;   R10=2
		tst temp1					;   
		breq mn_3					;  
		rjmp main					;
		
mn_1:	ldi temp1,1					;
		mov R10,temp1				; R10=1
		rjmp main					;
		
mn_2:	ldi temp1,2					;
		mov R10,temp1				; R10=2
		rjmp main					;
		
mn_au:	clr temp					;   , -
		sbr temp,4					; 
		mov r1,temp					;  R1=4
		rjmp mn_4					;
		
mn_3:	mov r1,R10					;   
		
		;   ()
mn_4:	DELAY 1						; 32  
		cp r1,r2					;  
		brne main					;  -  
		tst R2						;   ,-
		breq main					;  
		;  , .  
		mov temp,R2					;
		cpi temp,0x4				;   , -
		brne PC+3					;
		rcall mode_s				;   
		rjmp m_loop					; 
		;  
		tst R8						;   
		brne avto					;    
		;  
		sbrc R10,0					;  , -
		rcall St_Up					;     
		sbrc R10,1					;  , -
		rcall St_Down				;     
		rjmp m_loop					; , -  
		;
avto:	sbrc R10,0					;  , -
		rcall freq_Up				;    
		sbrc R10,1					;  , -
		rcall freq_Down				;    
		
m_loop: clr R10						;
		clr R2						;
		rjmp main					;   
		
;===========================================================================
mode_s:		;   /
		DELAY 20					;
		tst R8						;   
		brne rev					;
		mov R8,R2					;  
		rjmp rev_end				;
rev:	clr R8						;  
		
rev_end:clr temp					; temp    
 		ret
;===========================================================================
freq_Up:	;   "+"   
		inc freq					; 
		cpi freq,210				;    >210
		brlo PC+2					; 210+870=1080
		clr freq					;  freq =0
			;  ""
		POZ_LCD 0,5					;0- , 5- 
		LOAD_ADDR Z,Messg5*2		;.  Z  
		rcall Str_LCD				; .  LCD
		rcall Mono					; ""
			;     
		ldi temp,0b10010011			;(02H) ., DMUTE=0,,,
									; SEEKUP=1, SEEK=1 ( )
		mov r5,temp					; - 
r_con:	rcall Config_RDA5807		; 
		
nov_p:	DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_p					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		cpi freq,210				;    >210
		brlo PC+2					; 210+870=1080
		clr freq					;  freq =0
		rjmp r_con					;  
		
		rjmp st_tn					;  
		clr temp					; temp    
 		ret
;===========================================================================
freq_Down:		;   "-"   
		dec freq					; 
			;  ""
		POZ_LCD 0,5					;0- , 5- 
		LOAD_ADDR Z,Messg5*2		;.  Z  
		rcall Str_LCD				; .  LCD
		rcall Mono					; ""
			;     
		ldi temp,0b10010001			;(02H) ., DMUTE=0,,,
									; SEEKUP=0, SEEK=1 ( )
		mov r5,temp					; - 
rm_con:	rcall Config_RDA5807		; 
		
nov_m:	DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_m					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		tst freq					;    =0
		brne PC+2					; 210+870=1080
		ldi freq,210				;  freq =210
		rjmp rm_con					;  
		
		;     
st_tn:	ldi temp,0b11010010			;(02H) ., DMUTE=1,,,
									; SEEKUP=1, SEEK=0 ( )
		mov r5,temp					; - 
		rcall Config_RDA5807		; 
		
		sbrc r17,2					; , -
		rcall Ster					; ""
		rcall type_lev				;  
		rcall rekog					; 
		rcall Prnt_F				;   
		
		clr temp					; temp    
 		ret
;===========================================================================
 St_Up:			;     FLASH
		LOAD_ADDR Z,freq_st*2		;.  Z . ..
		;  
		inc R9						;  
		mov temp,R9
 		cpi temp,Nst				;    > Nst
 		brlo st_u					;
 		clr R9						;     
 		rjmp st_set					;
 		
;---------------------------------------------------------------------------
St_Down:	;     FLASH
		LOAD_ADDR Z,freq_st*2		;.  Z . ..
		;  
 		dec R9						;   ,
 		tst R9						;   > 0,  
 		brpl st_u					;   ,  -
 		ldi temp,(Nst-1)			;     
 		mov R9,temp
 		;     . 
 st_u:	breq st_set					;  =0,   
 		push R9						;
		adiw Z,16					;    . 
		dec R9						;
		brne PC-2					;
		pop R9						;
		
st_set:	lpm freq,Z					;   FLASH
		adiw Z,1					;    
		rcall Print					;    
		rcall Prnt_F				;   
		;   
		ldi temp,0b11010010			;(02H) ., DMUTE=1,,,
									 ;SEEKUP=1, SEEK=0 ( )
		mov r5,temp					;
		rcall Config_RDA5807		;  /
		
		rcall Mono					; ""
		DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		
		lds r17,seek_fm				;  . 
		sbrc r17,2					; , -
		rcall Ster					; ""
		rcall type_lev				;  
		
		clr temp					; temp    
		
		ret
		
;===========================================================================
;		/  
;---------------------------------------------------------------------------
rekog:	clr R9						;
		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
rd_fr:	lpm temp,Z					;   FLASH
		cp temp,freq				;  ,   ,  -
		breq na_ind					;    
		inc R9						;  
		mov temp,R9					;  , 
		cpi temp,Nst				;    , -
		brsh fall					;  . ". "
		adiw Z,16					;   
		rjmp rd_fr					;  
		
fall:	LOAD_ADDR Z,Messg2*2		;.  Z . . ". "
		rjmp PC+2					;  
na_ind:	adiw Z,1					;    
			;    
Print:	POZ_LCD 0,5					;0- , 5- 
		rcall Str_LCD				;   
		
		ret
		
;===========================================================================
;			 /   RDA5807M
;---------------------------------------------------------------------------
Read_RDA5807:
		rcall IIC_Start			;  
		ldi temp,0b00100001		;   021
		rcall IIC_Send			;  
		
		rcall IIC_Recieve		;(0)   
		sts seek_fm,temp		;    . 
		
		rcall IIC_Recieve		;(0L)   
		sts read_fm,temp		;     
		mov freq,temp			;     
		
		rcall IIC_Recieve_lst	;(0B)   
		lsr temp				;   
		sts level,temp			;      
		
		rcall IIC_Stop			;  
		
		ret
		
;===========================================================================
;	 /    , ( YH:YL   )
;---------------------------------------------------------------------------
Rd_St:	ldi YL,LOW(Fst_EE)			;.  Y . ..
		clr YH						; .   
		clr freq					;
Rd_EEF:	sbic EECR,EEWE				;   
		rjmp Rd_EEF					;
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		sbi EECR,EERE				;  
		in freq,EEDR				;   . 
		
		ret
;===========================================================================
; 			    RDA5807
;---------------------------------------------------------------------------
Config_RDA5807: 
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;     
; .F_3H . 8  .  .F_3L .2  . &  ..
		mov F_3H,freq				;
		clc							;  
		clr F_3L					;
		lsr F_3H					;
		ror F_3L					;
		lsr F_3H					;
		ror F_3L					;
		ori F_3L,0x10				;   
		;     RDA5807
		rcall iic_start				; 
		ldi temp,0x20				;    RDA5807
		rcall IIC_Send				;  
		
		mov temp,r5					;   -
		rcall IIC_Send				;(02) = r5
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		mov temp,F_3H				;(03H) . 8  
		rcall IIC_Send				;
		mov temp,F_3L				;(03L) .2  . &  ..
		rcall IIC_Send				;	87108 MHz	 100 
		
		ldi temp,0					;(04H)
		rcall IIC_Send				;
		ldi temp,0					;(04L)
		rcall IIC_Send				;
		
		ldi temp,0b10001000 		;(05H)- .,  . 
		rcall IIC_Send				;
		lds temp,volume				;(05L)     
		ori temp,0b10000000			;
		rcall IIC_Send				;  
		
		rcall iic_stop 				; 
		rcall Wr_EEF				;    
		
		pop R16          		;   SREG
    	out SREG,R16     		;
    	pop R16          		;   R16
		ret
;===========================================================================
;		    ,  YH:YL   
;---------------------------------------------------------------------------
Wr_EEF:	ldi YL,LOW(Fst_EE)			;.  Y . ..
		clr YH						; .   
		sbic EECR,EEWE				;  
		rjmp PC-1					;   EEWE
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		out EEDR,freq				;  
		sbi EECR,EEMWE				;   
		sbi EECR,EEWE				;  
		
		ret
		
;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_lev:	;    LCD
		POZ_LCD 1,0					;1- , 0- 
		lds temp,level				;     
		
		cpi temp,51					; 4- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg10*2		;.  Z . . " 4"
		rjmp tp_lev					;    /
		
		cpi temp,38					; 3- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg9*2		;.  Z . . " 3"
		rjmp tp_lev					;    /
		
		cpi temp,25					; 2- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg8*2		;.  Z . . " 2"
		rjmp tp_lev					;    /
		
		cpi temp,12					; 1- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg7*2		;.  Z . . " 1"
		rjmp tp_lev					;    /
		
		LOAD_ADDR Z,Messg6*2		;.  Z . . " 0"
		
tp_lev:	rcall Str_LCD				;   
		
		ret

;===========================================================================
; /     0
;---------------------------------------------------------------------------
OVF_T0:	
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;
		dec time			; 
		tst time			;
		brne vyh			;
		
t_1:	tst r1				;     
		breq vyh			;   /,  -
		mov r2,r1			;    
		
vyh:	pop R16          	;   SREG
    	out SREG,R16     	;
    	pop R16          	;   R16
		
		reti
		
;===========================================================================
;		    LCD 
;---------------------------------------------------------------------------
 Prnt_F:		;      
		;    LCD
		clr R6					;    
		inc R6					; 1-  
		POZ_LCD 1,2				;1- , 2- 
		;    
		clr r18					;
		ldi r17,HIGH(870)		;   
		ldi temp,LOW(870)		; : 870  
		add temp,freq			;   
		adc r17,r18				;
		;   10- 
		rcall bin16_dec5		;  10- 
		ldi YL,LOW(decnum)		;.  X . .   
		clr YH					;
		ldi temp,3				; .    
		add YL,temp				;
		
		ld temp,Y				; .  
		tst temp				;    0,  -
		brne PC+4				;    
		ldi temp,0x0A			;  
		rcall Dig_x2			;  LCD 
		rjmp PC+2				
		rcall Dig_x2			;  
		
		ld temp,-Y				; .  
		rcall Dig_x2			;  
		
		ld temp,-Y				; .  
		rcall Dig_x2			;  
		
		;  LCD 
		ldI temp,0x20			;   
		rcall lcd_put_char		;
		POZ_LCD 7,3				;7- , 3- 
		ldI temp,127			; 
		rcall lcd_put_char		;  LCD 
		
		inc R6					;  
		POZ_LCD 8,2				;8- , 2- 
		ld temp,-Y				; .  
		rcall Dig_x2			;   
		
		;    ""
		POZ_LCD 10,3			;10- , 3- 
		LOAD_ADDR Z,Messg4*2	;.  Z . . ""
		rcall Str_LCD			;   
		
		ret
		
;===========================================================================
;    ""
;---------------------------------------------------------------------------
Mono:	push R30
		push R31
		;    LCD
		POZ_LCD 13,1					;12- , 1- 
		ldi temp,'M'					;
		rcall lcd_put_char				;  LCD
		
		cbi PORTB,0						; 
		pop R31
		pop R30
		ret
		
;===========================================================================
;    ""
;---------------------------------------------------------------------------
Ster:	push R30
		push R31
		;    LCD
		POZ_LCD 13,1					;12- , 1- 
		ldi temp,'S'					;
		rcall lcd_put_char				;  LCD
		
		sbi PORTB,0						; 
		pop R31
		pop R30
		ret
		
;===========================================================================
;  2-    5-
;  (  d4d0   SRAM )
;
; R17:R16    ,    (00xFFFF)
; R18,R19,R20   
; [YH:YL]        YH:YL
; decnum      
;---------------------------------------------------------------------------
 bin16_dec5:
 	push R18
 	push R19
 	push R20
     ldi   YL,low(decnum) 	;   Y 
     ldi   YH,high(decnum) 	;    d0d4  
     ldi   R20,4    		;   
bd1: clr   R18      		;   R18
     ldi   R19,16   		;    
bd2: lsl   R16      		;   V(D)/10
     rol   R17      		;     R17:R16,
     rol   R18      		;    R18 = di
     andi  R16,0xFE
     cpi   R18,10
     brcs  bd3
     subi  R18,10
     ori   R16,0x01
bd3: dec   R19
     brne  bd2
     st    Y+,R18   		;  di  
     dec   R20
     brne  bd1      		;  n-1 
     st    Y+,R16   		;   dn-1  
    pop R20
    pop R19
    pop R18
     ret

;=========================================================================
;******************************************************************************
	.include "I2C_hard_driver.asm"		;   I2C
	;.include "I2C_soft_driver.asm"		;   I2C
 	.include "Nokia5110_driver.asm"		; LCD Nokia5110
 	.include "Font_6x8.asm" 			;  
;******************************************************************************
;===========================================================================
		;      

 ; Messg1: .DB  '!','"','"',' ','/',' ',' ',' ',' ',' ',' ',' ',' ',' ', 0
  Messg1: .DB  '!','"','"',' ','F','M',' ','8','7','-','1','0','8',' ', 0
  Messg2: .DB  " .  ", 0
 ; Messg3: .DB  "          ", 0
  Messg4: .DB  "", 0
  Messg5: .DB  "     ", 0
  Messg6: .DB  '"','"', 0			; 0
  Messg7: .DB  '#','"', 0			; 1
  Messg8: .DB  '$','"', 0			; 2
  Messg9: .DB  '$','%', 0			; 3
  Messg10: .DB '$','&', 0			; 4
  Messg11: .DB "  ",0
  Messg12: .DB "",0
  
;-------------------------------------------------------------------------------
	freq_st:		;  FM-  
 	.DB  41,' ',' ','','','','','','','','','',' ',' ',' ',0   	; 	    911  29
  	.DB  46,' ',' ',' ','','','','',' ','','',' ',' ',' ',' ',0 	   	; FM	    916	 2E
  	.DB 121,' ',' ',' ','','','','','','','',' ',' ',' ',' ',0   	;	    991	 79
  	.DB 132,' ',' ','','','','',' ','','','','','',' ',' ',0   	; 	   1002	 84
  	.DB 140,' ','','','','','',' ','','','','','','',' ',0   	;   1010	 8C
  	.DB 144,' ',' ',' ','','','','','',' ','','',' ',' ',' ',0  		; FM	   1014	 90
  	.DB 157,' ',' ','','','','',' ','','','','','',' ',' ',0   	; 	   1027	 9D
  	.DB 162,' ','','','','','','',' ','','','','',' ',' ',0  		;    1032	 A2
  	.DB 166,' ',' ',' ','','','','','','','','',' ',' ',' ',0   	;	   1036  A6
  	.DB 177,' ',' ','','','','','','',' ','','',' ',' ',' ',0    	;DJ-FM		   1047  B1
  	.DB 182,' ',' ',' ','','','','','',' ','','',' ',' ',' ',0   	;Kiss FM	   1052  B6
  	.DB 189,'','','','','','','',' ','','','','','',' ',0     	;  1059  BD
  	.DB 199,' ',' ',' ',' ','','','',' ','','',' ',' ',' ',' ',0   	; FM		   1069  C7
	.DB 204,' ',' ',' ',' ','','','',' ','','',' ',' ',' ',' ',0  		; FM		   1074  CC
		;
;=================================================================================


	.EXIT
	
	
